/*
** This file is completely free, in every sense of the word.
** Do whatever you like with it, just beware that you use this
** code entirely at your own risk. I don't accept any liability
** whatsoever for any loss or damage caused by the use or
** misuse of this code.
**
** Jo Even Skarstein
** joska@nvg.org
** http://joska.nvg.org/
*/

#include <aes.h>
#include <osbind.h>
#include <string.h>
#include "dhst.h"
#include "cookie.h"

#define	AVSTR2MSG(msg,offset,str)	(*(char **)(msg+offset) = str)
#define	AVMSG2STR(msg,offset)		((char *)(((long)msg[offset]<<16)|(((long)msg[offset+1])&0xffff)))

#ifndef TRUE
#define TRUE 1
#define FALSE 0
#endif

extern int gl_apid;

static int dhst_apid;
static DHSTINFO *dhst_global;
static int lock_dhst_buffer = FALSE;
static char gl_appname[33] = {"Nugatti\0"}, gl_apppath[1000] = {"c:\nugatti.app\0"};

int dhst_init(char *appname, char *apppath)
{
	long cookie_value;
	if (!get_cookie('DHST', &cookie_value))
	{
		return FALSE;
	}

	dhst_global = (DHSTINFO *)Mxalloc(4*1024, 0x0003|0x0028);
	if (!dhst_global)
	{
		return FALSE;
	}

	dhst_global->appname = (char *)dhst_global + sizeof(DHSTINFO);
	dhst_global->apppath = dhst_global->appname + 33;
	dhst_global->docname = dhst_global->apppath + 1000;
	dhst_global->docpath = dhst_global->docname + 65;

	if (appname)
	{
		strncpy(gl_appname, appname, 32);
		strncpy(dhst_global->appname, appname, 32);
	}
	
	if (apppath)
	{
		strncpy(gl_apppath, apppath, 999);
		strncpy(dhst_global->apppath, apppath, 999);
	}
	
	dhst_apid = (int)cookie_value;
	return TRUE;
}

int dhst_add(char *docname, char *docpath, char *appname, char *apppath)
{
	int msg[8] = {DHST_ADD, 0,0,0,0,0,0,0};
	
	if (!lock_dhst_buffer)
	{
		lock_dhst_buffer = TRUE;

		strncpy(dhst_global->docname, docname, 64);
		strncpy(dhst_global->docpath, docpath, 999);

		if (appname)
			strncpy(dhst_global->appname, appname, 32);
		else
			strncpy(dhst_global->appname, gl_appname, 32);
	
		if (apppath)
			strncpy(dhst_global->apppath, apppath, 999);
		else
			strncpy(dhst_global->apppath, gl_apppath, 999);

		msg[1] = gl_apid;
		AVSTR2MSG(msg, 3, (char *)dhst_global);
		return appl_write(dhst_apid, (int)sizeof(msg), msg);
	}
	
	return FALSE;
}

int dhst_ack(char *buffer)
{
	lock_dhst_buffer = FALSE;
	return TRUE;
}