/*
** This file is completely free, in every sense of the word.
** Do whatever you like with it, just beware that you use this
** code entirely at your own risk. I don't accept any liability
** whatsoever for any loss or damage caused by the use or
** misuse of this code.
**
** Jo Even Skarstein
** joska@nvg.org
** http://joska.nvg.org/
*/

#include <string.h>
#ifndef TRUE
#define TRUE 1
#define FALSE 0
#endif

short quote(char *dest, char *source, short length)
{
	char *s = source, *d = dest;
	int quote = FALSE;

	/*
	** Quote it?
	*/
	while (*s != '\0')
	{
		if (*s == ' ')
		{
			quote = TRUE;
			break;
		}
		s++;
	}
	
	s = source;
	if (!quote)
	{
		/*
		** Just copy source to dest
		*/
		for(; *s != '\0' && (s - source) < length; *d = *s++); *s = '\0';
		d[length] = '\0';
		return FALSE;
	}
	else
	{
		/*
		** Quote
		*/
		d = source;
		*d++ = '\'';
		while (*s != '\0' && s < (source + length - 2))
		{
			if (*s == '\'')
			{
				*d++ = '\'';
				break;
			}
			*d++ = *s++;
		}
		*d++ = '\''; *d = '\0';
	}

	return TRUE;
}

short unquote(char *dest, char *source)
{
	int unquoted = FALSE;
	
	char *s = source, *d = dest;
	
	while (*s != '\0')
	{
		if (*s == '\'')
		{
			s++;
			unquoted = TRUE;
		}

		*d++ = *s++;
	}
	*d = '\0';

	return unquoted;
}